# Find subdir/filename along the prefix and readonly-prefixes.
# The directory where the file has been found is stored 
# in the output variable "directory"
FUNCTION(ConfixFindNativeInstalledFile directory filename subdir)
    SET(my_path ${CMAKE_INSTALL_PREFIX}/${subdir})
    FOREACH(dir ${READONLY_PREFIXES})
        LIST(APPEND my_path ${dir}/${subdir})
    ENDFOREACH(dir)
    FIND_PATH(${directory} ${filename} PATH ${my_path} NO_DEFAULT_PATH)
ENDFUNCTION(ConfixFindNativeInstalledFile)

FUNCTION(ConfixFindNativeInstalledLibrary basename exename)
    SET(prefixlib_list ${CMAKE_INSTALL_PREFIX}/lib)
    FOREACH(prefix ${READONLY_PREFIXES})
        LIST(APPEND prefixlib_list ${prefix}/lib)
    ENDFOREACH(prefix)
    FIND_LIBRARY(${basename}_LIBRARY ${basename} ${prefixlib_list})
    IF (NOT ${basename}_LIBRARY)
        MESSAGE(FATAL_ERROR "cannot find confix native installed library '${basename}'")
    ENDIF (NOT ${basename}_LIBRARY)
ENDFUNCTION(ConfixFindNativeInstalledLibrary)
